class GameState
{
public:
	GameState();
	~GameState();

	bool NextState();
	void RenderState();
	
	void NextLevel();
	void LoadLevel(char *filename);

	void CreateHero();
	void NextHeroFrame();
	void NextHeroMove();
	void NextHeroState();
	void RenderHero();
	
	void NextNaniteFrame();
	void NextNaniteMove();
	void NextNaniteState();
	void RenderNanites();

	void NextParticleState();
	void RenderParticles();

	void RenderBeam();
	void RenderLevel();
	void RenderHud();

	void RenderStory();
	bool RenderTitle();
	void RenderEnding();

	void PlayMusic();
	void StopMusic();

	void FadeOut();

	void PerformCollisionMods();

	int					score;
	int					timer;
	int					currentLevel;
	bool				levelCompleted;
	bool				gameOver;

private:


	enum DirectionalState
	{
		up = 0,
		right,
		down,
		left
	};

	enum MovementState
	{
		still = 0,
		moving,
		random,
		merging
	};

	enum ActionState
	{
		donothing = 0,
		shooting,
		dying,
		dead,
		hit
	};
	
	struct Hero
	{
	  int				x,y;
	  int				lifePower;
	  int				beamPower;
	  int				frame;
	  int				invincibleCount;
	  DirectionalState	directionalState;
	  MovementState		movementState;
	  ActionState		actionState;
	};

	struct BloodParticle
	{
		int x;
		int y;
		int dx;
		int dy;
		int life;
	};

	struct Nanite
	{
	  int				x,y;
	  bool				disabled;
	  int				dx,dy;
	  int				frame;
	  DirectionalState	directionalState;
	  MovementState		movementState;
	};


	int					cameraX;
	int					cameraY;


	BITMAP				*gameGraphics;
	BITMAP				*doubleBuffer;
	BITMAP				*levelMap;
	BITMAP				*preRenderedLevel;

	Hero					hero;
	vector <Nanite>			nanites;
	vector <BloodParticle>	particles;
	
	SAMPLE				*laserSound;  bool laserSoundPlaying;
	SAMPLE				*splatSound;  bool splatSoundPlaying;
	SAMPLE				*shakeSound;  bool shakeSoundPlaying;
	SAMPLE				*oofSound;
	SAMPLE				*naniteSound1;

	MIDI				*bgMusic;

};

